
#include "common.h"
#include "Console.h"
#include "Player.h"
#include "Enemy.h"
#include "EnemyManager.h"	
#include "Shot.h"
#include "ShotManager.h"

void InitialObject(void);
void PlayerAction(void);
void DrawPlayer(void);
void Draw(void);
void EnemyAction(void);
void DrawEnemy(void);
//void CreateShot(int Type, int x, int y);
void ShotAction(void);
void DrawShot(void);
void CheckCrush(void);
int CheckClear(void);
int CheckGameEnd(void);

int main(void)
{
	Initial();				//	ܼ ȭ â ʱȭ
	InitialObject();		//	Ʈ ʱȭ
	
	srand( (unsigned int)time(NULL) );

	while (1) 
	{
		PlayerAction();		//	÷̾ ̵
		EnemyAction();		//	ʹ ̵
		ShotAction();		//	÷̾&ʹ Ѿ ̵

		Draw();				//	Ʈ ܼȭ鿡 
		
		CheckCrush();		//	浹üũ
		
		//	   üũ
		if (CheckGameEnd()) 
			break;

		Sleep(100);
	}

	return 0;
}

void InitialObject(void)
{
	EnemyManager::GetInstance()->Init();
	
	Player::GetInstance()->Init(39,19);
}

void PlayerAction(void)
{
	Player::GetInstance()->PlayerAction();
	
	//	Ʈ Ű  ÷̾ Ѿ 
	if ( GetAsyncKeyState(VK_CONTROL) & 0x8000 ) 
		ShotManager::GetInstance()->CreateShot( 
		Player::GetInstance()->GetX(), Player::GetInstance()->GetY(), PLAYER_SHOT 
		);
}

void DrawPlayer(void)
{
	Player::GetInstance()->DrawPlayer();
}

void Draw(void)
{
	int i;
	
	for ( i = 0; i < HEIGHT; i++ ) 
	{
		memset(Screen[i], ' ', WIDTH);	
		Screen[i][WIDTH - 1] = 0;		
	}
	
	DrawPlayer();
	
	DrawEnemy();		
	
	DrawShot();			

	for ( i = 0; i < HEIGHT; i++ ) 
	{
		MoveCursor(0, i);		
		printf( Screen[i] );	
	}
}

void EnemyAction(void)
{
	EnemyManager::GetInstance()->EnemyAction();

	//	ʹ Ѿ 
	for ( int i = 0; i < EnemyManager::GetInstance()->GetArrLen(); i++ ) 
	{
		Enemy* pEnemy = EnemyManager::GetInstance()->GetEnemyByIdx(i);

		if ( pEnemy == NULL ) 
			continue;
		
		if ( pEnemy->GetLiveFlag() == 0 )
			continue;
		
		//	1% Ȯ Ѿ 
		if ( rand() % 100 < 1 )
		{	
			ShotManager::GetInstance()->CreateShot( 
			pEnemy->GetX(), pEnemy->GetY(), ENEMY_SHOT 
			);	
		}
	}
}

void DrawEnemy(void)
{
	EnemyManager::GetInstance()->DrawEnemy();
}

void ShotAction(void)
{
	//	ShotManager Ŭ Լ ȣ
	ShotManager::GetInstance()->ShotAction();
}

void DrawShot(void)
{
	//	ShotManager Ŭ Լ ȣ
	ShotManager::GetInstance()->DrawShot();
}

void CheckCrush(void)
{
	//	ShotManager Ŭ Լ ȣ
	ShotManager::GetInstance()->CheckCrush();
}

int CheckClear(void)
{
	return EnemyManager::GetInstance()->CheckClear();
}

int CheckGameEnd(void)
{
	if ( Player::GetInstance()->GetLiveFlag() == 0 ) 
	{
		system("cls");
		MoveCursor(36, 12);
		printf(" !!");
		Sleep(1000);

		return 1;	
	}
	
	if ( CheckClear() ) 
	{
		system("cls"); 
		MoveCursor(36, 12);
		printf(" ̰!!");
		Sleep(1000);

		return 1;	
	}
	
	return 0;
}